<?php

/**
 * The admin-specific functionality of the plugin.
 *
 * @link       https://rankfortress.com/
 * @since      1.0.0
 *
 * @package    Location_Geocentric
 * @subpackage Location_Geocentric/admin
 */

class Location_Geocentric_Admin {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

    private $apiKey = 'AIzaSyA1aglDVH6dzvkugPk5N5XkwdKba_GvpPc';

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of this plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

        $settingsOptions = get_option( 'rankfortress_settings' );
		$this->plugin_name = $plugin_name;
		$this->version = $version;
        $this->apiKey = $settingsOptions['rankfortress_gmap_api'];
	}

	/**
	 * Register the stylesheets for the admin area.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_styles() {

        wp_enqueue_style( 'bootstrap', plugin_dir_url( __FILE__ ) . 'css/admin.css', array(), $this->version, 'all' );
        
	}

	/**
	 * Register the JavaScript for the admin area.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_scripts() {

        wp_enqueue_style( 'wp-color-picker' );
		wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/admin.js', array( 'jquery', 'wp-color-picker' ), $this->version, true );
        wp_enqueue_script( $this->plugin_name . '-gmap', 'https://maps.googleapis.com/maps/api/js?key='.$this->apiKey.'&libraries=places&v=weekly', array(), false, false );
        

	}

}