<?php
/**
 * @internal never define functions inside callbacks.
 * these functions could be run multiple times; this would result in a fatal error.
 */
 
/**
 * custom option and settings
 */
function rankfortress_settings_init() {
    // Register a new setting for "rankfortress" page.
    register_setting( 'rankfortress', 'rankfortress_options' );
    register_setting( 'rankfortress_settings', 'rankfortress_settings' );
 
    section_design();
    fields_design();

    section_settings();
    fields_settings();

    //add_settings_field( $id:string, $title:string, $callback:callable, $page:string, $section:string, $args:array )
}


add_action( 'admin_init', 'rankfortress_settings_init' );

function section_design(){

    // Register a new section in the "rankfortress" page.
    add_settings_section(
        'rankfortress_design_styling',
        __( 'Styling', 'rankfortress' ), 'rankfortress_section_styling_cb',
        'rankfortress'
    );

    add_settings_section(
        'rankfortress_design_spacing',
        __( 'Spacing', 'rankfortress' ), 'rankfortress_section_spacing_cb',
        'rankfortress'
    );
    
}

function section_settings(){

    // Register a new section in the "rankfortress" page.
    add_settings_section(
        'rankfortress_settings_neighborhood',
        __( 'Neighborhood', 'rankfortress' ), 'rankfortress_settings_neighborhood_cb',
        'rankfortress_settings'
    );

    add_settings_section(
        'rankfortress_settings_activities',
        __( 'Activities', 'rankfortress' ), 'rankfortress_settings_activities_cb',
        'rankfortress_settings'
    );

    add_settings_section(
        'rankfortress_settings_location',
        __( 'Location Information', 'rankfortress' ), 'rankfortress_settings_location_cb',
        'rankfortress_settings'
    );

    add_settings_section(
        'rankfortress_settings_map',
        __( 'Google Map', 'rankfortress' ), 'rankfortress_settings_map_cb',
        'rankfortress_settings'
    );

    add_settings_section(
        'rankfortress_settings_api',
        __( 'Google Map API', 'rankfortress' ), 'rankfortress_settings_api_cb',
        'rankfortress_settings'
    );

    add_settings_section(
        'rankfortress_settings_ow_api',
        __( 'OpenWeather API', 'rankfortress' ), 'rankfortress_settings_ow_api_cb',
        'rankfortress_settings'
    );
    
}
 

function rankfortress_settings_neighborhood_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This are the default options applied to all shortcodes. Defining the values directly in the shortcode will override the values define on this page.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_settings_activities_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This are the default options applied to all shortcodes. Defining the values directly in the shortcode will override the values define on this page.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_settings_location_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This are the default options applied to all shortcodes. Defining the values directly in the shortcode will override the values define on this page.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_settings_map_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This are the default options applied to all shortcodes. Defining the values directly in the shortcode will override the values define on this page.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_settings_api_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'Add your google map api key.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_settings_ow_api_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'Add your open weather api key.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_section_styling_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This will change the appearance of each component title, paragraph and list.', 'rankfortress' ); ?>
</p>

<?php

}

function rankfortress_section_spacing_cb( $args ) {
    ?>
<p id="<?php echo esc_attr( $args['id'] ); ?>">
    <?php esc_html_e( 'This will change spacing between components.', 'rankfortress' ); ?>
</p>

<?php

}
 
/**
 * Add the top level menu page.
 */
function rankfortress_options_page() {
    add_menu_page(
        'Rank Fortress Settings',
        'Rank Fortress',
        'manage_options',
        'rank-fortress',
        'rankfortress_options_page_html',
        plugins_url( 'admin/img/logo-colored.png', dirname(__FILE__) )
    );

    $appsero = new Appsero();

    if( $appsero->appsero_check_license() ){
        add_submenu_page( 'rank-fortress', 'Neighborhoods', 'Neighborhoods', 'manage_options', 'rankfortress-neighborhood', 'neighborhood_html');
    }
}
 
 
/**
 * Register our rankfortress_options_page to the admin_menu action hook.
 */
add_action( 'admin_menu', 'rankfortress_options_page' );
 
function rankfortress_options_page_html(){
?>
<div class="wrap rkfrt-dashboard">

    <figure class="rkfrt-dashboard__logo"><img
            src="<?php echo plugins_url( 'admin/img/logo.png', dirname(__FILE__) ); ?>" alt=""></figure>



    <div class="rkfrt-dashboard__content">

        <div class="rkfrt-dashboard__author">
            <div class="rkfrt-col rkfrt-dashboard__author-details">
                <h2>About the author</h2>
                <p>I am a Philippines-based SEO Expert that has been in the marketing and SEO industry for over 20
                    years. I have a passion and desire to help business owners like myself to achieve what has always
                    seemed unattainable results.</p>

                <p>If you have had difficulty in obtaining results then you’re in luck and have come to the right
                    place. I am NOT the typical SEO in fact I hate the term SEO.</p>

                <p>I am a self-taught Business Owner that has built my experience on actual real-world results and NOT
                    theory from the talking heads of the SEO Industry or the armchair SEO Magicians.</p>

                <p>The strategies I teach are the same proven strategies and techniques that I use in My agency (Rank
                    Fortress) every single day. In fact, the very same strategies I teach are the same ones that I use
                    to train My SEO staff. These are time-tested techniques that are proven to get you results if you
                    apply them.</p>

                <p>So sit back, get a pencil and paper and be prepared to throw away almost everything you have learned
                    from the so-called SEO magicians and learn what it takes to rank your business with Google.</p>
                <div class="rkfrt-mini-card">
                    <img width="200" src="<?php echo plugins_url( 'admin/img/signature.png', dirname(__FILE__) ); ?>"
                        alt="">
                    <a href="https://rankfortress.com/product/seo-consultation/"><img width="200"
                            src="<?php echo plugins_url( 'admin/img/book-call.jpg', dirname(__FILE__) ); ?>" alt=""></a>
                </div>
            </div>
            <div class="rkfrt-col">
                <img src="https://rankfortress.com/wp-content/uploads/2021/06/me-768x1024-1.webp" alt="">
            </div>
        </div>

        <hr>

        <div class="rkfrt-dashboard__about">
            <h2>SEO Courses</h2>
        </div>

    </div>

    <div class="rkfrt-dashboard__footer">
        <p>&copy; 2021 RANK FORTRESS DIGITAL AGENCY</p>

        <div class="rkfrt-dasboard__social">
            <div>
                <a href="https://www.youtube.com/channel/UCbvW5Kcj5CuA0r2mD1kaHxA"><span><svg
                            xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512">
                            <path
                                d="M549.655 124.083c-6.281-23.65-24.787-42.276-48.284-48.597C458.781 64 288 64 288 64S117.22 64 74.629 75.486c-23.497 6.322-42.003 24.947-48.284 48.597-11.412 42.867-11.412 132.305-11.412 132.305s0 89.438 11.412 132.305c6.281 23.65 24.787 41.5 48.284 47.821C117.22 448 288 448 288 448s170.78 0 213.371-11.486c23.497-6.321 42.003-24.171 48.284-47.821 11.412-42.867 11.412-132.305 11.412-132.305s0-89.438-11.412-132.305zm-317.51 213.508V175.185l142.739 81.205-142.739 81.201z">
                            </path>
                        </svg></span><span class="social-item-label">YouTube</span></a>
                <a href="https://www.facebook.com/filamrushdigitalmarketingagency"><span><svg
                            xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512">
                            <path
                                d="M279.14 288l14.22-92.66h-88.91v-60.13c0-25.35 12.42-50.06 52.24-50.06h40.42V6.26S260.43 0 225.36 0c-73.22 0-121.08 44.38-121.08 124.72v70.62H22.89V288h81.39v224h100.17V288z">
                            </path>
                        </svg></span><span class="social-item-label">Facebook</span></a>
                <a href="https://www.linkedin.com/in/rankfortress/" aria-label="linkedin" target="_blank"><span><svg
                            xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512">
                            <path
                                d="M100.28 448H7.4V148.9h92.88zM53.79 108.1C24.09 108.1 0 83.5 0 53.8a53.79 53.79 0 0 1 107.58 0c0 29.7-24.1 54.3-53.79 54.3zM447.9 448h-92.68V302.4c0-34.7-.7-79.2-48.29-79.2-48.29 0-55.69 37.7-55.69 76.7V448h-92.78V148.9h89.08v40.8h1.3c12.4-23.5 42.69-48.3 87.88-48.3 94 0 111.28 61.9 111.28 142.3V448z">
                            </path>
                        </svg></span>
                    <span class="social-item-label">linkedin</span></a>
                <a href="https://twitter.com/RankAgency" aria-label="twitter" target="_blank"
                    rel="noopener noreferrer"><span><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
                            <path
                                d="M459.37 151.716c.325 4.548.325 9.097.325 13.645 0 138.72-105.583 298.558-298.558 298.558-59.452 0-114.68-17.219-161.137-47.106 8.447.974 16.568 1.299 25.34 1.299 49.055 0 94.213-16.568 130.274-44.832-46.132-.975-84.792-31.188-98.112-72.772 6.498.974 12.995 1.624 19.818 1.624 9.421 0 18.843-1.3 27.614-3.573-48.081-9.747-84.143-51.98-84.143-102.985v-1.299c13.969 7.797 30.214 12.67 47.431 13.319-28.264-18.843-46.781-51.005-46.781-87.391 0-19.492 5.197-37.36 14.294-52.954 51.655 63.675 129.3 105.258 216.365 109.807-1.624-7.797-2.599-15.918-2.599-24.04 0-57.828 46.782-104.934 104.934-104.934 30.213 0 57.502 12.67 76.67 33.137 23.715-4.548 46.456-13.32 66.599-25.34-7.798 24.366-24.366 44.833-46.132 57.827 21.117-2.273 41.584-8.122 60.426-16.243-14.292 20.791-32.161 39.308-52.628 54.253z">
                            </path>
                        </svg></span><span class="social-item-label">twitter</span></a>
            </div>
        </div>
    </div>

</div>
<?php

} 

/**
 * Top level menu callback function
 */
function neighborhood_html() {
    // check user capabilities
    if ( ! current_user_can( 'manage_options' ) ) {
        return;
    }
    // check if the user have submitted the settings
    // WordPress will add the "settings-updated" $_GET parameter to the url
    if ( isset( $_GET['settings-updated'] ) ) {
        // add settings saved message with the class of "updated"
        add_settings_error( 'rankfortress_messages', 'rankfortress_message', __( 'Settings Saved', 'rankfortress' ), 'updated' );
    }
 
    // show error/update messages
    settings_errors( 'rankfortress_messages' );

    //Get the active tab from the $_GET param
  $default_tab = null;
  $tab = isset($_GET['tab']) ? $_GET['tab'] : $default_tab;
    ?>
<div class="wrap">
    <h1><?php echo esc_html( get_admin_page_title() ); ?></h1>
    <!-- Here are our tabs -->
    <nav class="nav-tab-wrapper">
        <a href="?page=rankfortress-neighborhood"
            class="nav-tab <?php if($tab===null):?>nav-tab-active<?php endif; ?>">Available Shortcodes</a>
        <a href="?page=rankfortress-neighborhood&tab=design"
            class="nav-tab <?php if($tab==='design'):?>nav-tab-active<?php endif; ?>">Design</a>
        <a href="?page=rankfortress-neighborhood&tab=settings"
            class="nav-tab <?php if($tab==='settings'):?>nav-tab-active<?php endif; ?>">Settings</a>
        <a href="?page=rankfortress-neighborhood&tab=tools"
            class="nav-tab <?php if($tab==='tools'):?>nav-tab-active<?php endif; ?>">Tools</a>
    </nav>
    <div class="tab-content">
        <?php 
            switch($tab) :
            case 'settings':
                settings_tab();
                break;
            case 'design':
                design_tab();
                break;
            case 'tools':
                tool_tab();
                break;
            default:
            dashboard_tab();
                break;
            endswitch; 
        ?>
    </div>


</div>
<?php
}

function design_tab(){
?>

<form action="options.php" method="post">
    <?php
            // output security fields for the registered setting "rankfortress"
            settings_fields( 'rankfortress' );
            // output setting sections and their fields
            // (sections are registered for "rankfortress", each field is registered to a specific section)
            do_settings_sections( 'rankfortress' );
            // output save settings button
            submit_button( 'Save Settings' );
            ?>
</form>

<?php
}

function tool_tab(){
?>

<div class="rfa-block">
    <h2 class="rfa-heading">Place ID Finder</h2>
    <p>Use this tool to get the place_id and lat/lng of a location or business establishment. You need to use this for
        reviews shortcode.</p>
    <iframe
        src="https://rankfortress.com/location-geocentric/place_id_helper.html?key=AIzaSyA1aglDVH6dzvkugPk5N5XkwdKba_GvpPc"
        width="100%" height="500"></iframe>
</div>

<?php

}

function settings_tab(){
    ?>

<form action="options.php" method="post">
    <?php
                // output security fields for the registered setting "rankfortress"
        settings_fields( 'rankfortress_settings' );
        // output setting sections and their fields
        // (sections are registered for "rankfortress", each field is registered to a specific section)
        do_settings_sections( 'rankfortress_settings' );
        // output save settings button
        submit_button( 'Save Settings' );
    ?>
</form>

<?php
    }

function dashboard_tab(){
?>

<div class="rkfrt-admin-tab">
    <h2>Shortcodes</h2>
    <h4>Details of a Location (city).</h4>
    <pre><code>[rkfrt-details title="About New York City" location="New York City, New York" limit="10"]</code></pre>
    <h4>List of Neighborhoods.</h4>
    <pre><code>[rkfrt-neighborhoods title="New York" location="New York City" limit="30" sort="desc"]</code></pre>
    <h4>List of Activities in a Location (city).</hh43>
        <pre><code>[rkfrt-activities title="Things To Do in New York" location="New York City"  limit="30" sort="desc"]</code></pre>
        <h4>Google Map</h4>
        <pre><code>[rkfrt-map title="" location="New York City" zoom="8" neighborhood="true" activities="true"]</code></pre>
        <h4>Directions</h4>
        <pre><code>[rkfrt-directions title="" city="New York City" address="" pins="5"]</code></pre>
        <h4>Reviews</h4>
        <pre><code>[rkfrt-reviews place_id="" latlng=""]</code></pre>
        <h2>Shortcode Options</h2>
        <h3>[rkfrt-details]</h3>
        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>title</strong><br /><small>Title to show above the component.</small></td>
                    <td>Any text value</td>
                    <td>Location Name</td>
                </tr>
                <tr>
                    <td><strong>location</strong><br /><small>Use city name only. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small></td>
                    <td>Any text value</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>limit</strong><br />Sentence limit</td>
                    <td>Number from 1 to 1000</td>
                    <td>Define under settings tab</td>
                </tr>
            </tbody>
        </table>

        <h3>[rkfrt-neighborhoods]</h3>

        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>title</strong><br /><small>Title to show above the component.</small></td>
                    <td>Any text value</td>
                    <td>Location Name</td>
                </tr>
                <tr>
                    <td><strong>location</strong><br /><small>Use city name only. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small></td>
                    <td>Any text value</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>limit</strong><br />Limit the number of neighborhoods shown.</td>
                    <td>Number from 1 to 60</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>sort</strong><br /><small>Arrange the list in a prescried sequence.</small></td>
                    <td>asc | desc | rand</td>
                    <td>ascending or asc</td>
                </tr>
            </tbody>
        </table>

        <h3>[rkfrt-activities]</h3>

        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>title</strong><br /><small>Title to show above the component.</small></td>
                    <td>Any text value</td>
                    <td>Location Name</td>
                </tr>
                <tr>
                    <td><strong>location</strong><br /><small>Use city name only. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small></td>
                    <td>Any text value</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>limit</strong><br />Limit the number of activities shown.</td>
                    <td>Number from 1 to 60</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>sort</strong><br /><small>Arrange the list in a prescried sequence.</small></td>
                    <td>asc | desc | rand</td>
                    <td>ascending or asc</td>
                </tr>
            </tbody>
        </table>

        <h3>[rkfrt-map]</h3>

        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>title</strong><br /><small>Title to show above the component.</small></td>
                    <td>Any text value</td>
                    <td>none</td>
                </tr>
                <tr>
                    <td><strong>location</strong><br /><small>Use city name only. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small></td>
                    <td>Any text value</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>zoom</strong><br /><small>Set the zoom level from 0 (farthest) - 19 (nearest) for the
                            location.</small>
                    </td>
                    <td>Number from 0 to 19</td>
                    <td>Define under settings tab</td>
                </tr>
                <tr>
                    <td><strong>neighborhood</strong><br /><small>Set to true if you want to show the markers for each
                            neighborhood in the defined location.</small>
                    </td>
                    <td>true | false</td>
                    <td>false</td>
                </tr>
                <tr>
                    <td><strong>activities</strong><br /><small>Set to true if you want to show the markers for each
                            activities in the defined location.</small>
                    </td>
                    <td>true | false</td>
                    <td>false</td>
                </tr>
            </tbody>
        </table>

        <h3>[rkfrt-directions]</h3>

        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>title</strong><br /><small>Title to show above the component.</small></td>
                    <td>Any text value</td>
                    <td>none</td>
                </tr>
                <tr>
                    <td><strong>address</strong><br /><small>Add whole address. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small></td>
                    <td>Any text value</td>
                    <td>none</td>
                </tr>
                <tr>
                    <td><strong>city</strong><br /><small>Use city name only. Ensure that there are no whitespace
                            before<br />
                            the first letter and after the last letter.</small>
                    </td>
                    <td>Any text value</td>
                    <td>none</td>
                </tr>

                <tr>
                    <td><strong>pins</strong><br /><small>Set how many pins to show by default on load.</small></td>
                    <td>Any numbers between 1 - 10</td>
                    <td>5</td>
                </tr>

            </tbody>
        </table>

        <h3 style="margin-bottom: 0;">[rkfrt-reviews]</h3>
        <p>You can pull the values for place_id and latlng using our Place ID finder in <a
                href="?page=rankfortress-neighborhood&tab=tools">tools tab</a>. Only 5 reviews can be returned by
            google.
        <table class="widefat striped">
            <tbody>
                <tr>
                    <th>Option name</th>
                    <th>Possible values</th>
                    <th>Default values</th>
                </tr>
                <tr>
                    <td><strong>place_id</strong><br /><small>GMB Business unique place id</small></td>
                    <td>Value needs to be pull from google map finder</td>
                    <td>none</td>
                </tr>
                <tr>
                    <td><strong>latlng</strong><br /><small>GMB business lat ang lang coordinates</small></td>
                    <td>1.969696,1.969696</td>
                    <td>none</td>
                </tr>

            </tbody>
        </table>

</div>


<?php
}