<?php

function fields_design(){
    add_settings_field(
        'rankfortress_heading_font_size',
        __( 'Heading Font Size', 'rankfortress' ),
        'rankfortress_heading_font_size_cb',
        'rankfortress',
        'rankfortress_design_styling',
        array(
            'label_for'         => 'rankfortress_heading_font_size',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_heading_alignment',
        __( 'Heading Text Alignment', 'rankfortress' ),
        'rankfortress_heading_alignment_cb',
        'rankfortress',
        'rankfortress_design_styling',
        array(
            'label_for'         => 'rankfortress_heading_alignment',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_heading_font_color',
        __( 'Heading Font Color', 'rankfortress' ),
        'rankfortress_heading_font_color_cb',
        'rankfortress',
        'rankfortress_design_styling',
        array(
            'label_for'         => 'rankfortress_heading_font_color',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_paragraph_font_size',
        __( 'Paragprah Font Size', 'rankfortress' ),
        'rankfortress_paragraph_font_size_cb',
        'rankfortress',
        'rankfortress_design_styling',
        array(
            'label_for'         => 'rankfortress_paragraph_font_size',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_paragraph_font_color',
        __( 'Paragprah Font Color', 'rankfortress' ),
        'rankfortress_paragraph_font_color_cb',
        'rankfortress',
        'rankfortress_design_styling',
        array(
            'label_for'         => 'rankfortress_paragraph_font_color',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );


    add_settings_field(
        'rankfortress_margin_bottom',
        __( 'Margin', 'rankfortress' ),
        'rankfortress_margin_bottom_cb',
        'rankfortress',
        'rankfortress_design_spacing',
        array(
            'label_for'         => 'rankfortress_margin_bottom',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );
    
}


function rankfortress_heading_font_color_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_options' );
     
    ?>

<input type="text" class="color-picker" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    data-custom="<?php echo esc_attr( $args['rankfortress_custom_data'] ); ?>"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php
 }
 
 function rankfortress_heading_font_size_cb( $args ) {
 // Get the value of the setting we've registered with register_setting()
 $options = get_option( 'rankfortress_options' );
 
 ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    data-custom="<?php echo esc_attr( $args['rankfortress_custom_data'] ); ?>"
    value="<?php echo $options[$args['label_for']]; ?>" />

<p class="description">
    <?php esc_html_e( 'Define the font size value in Pixel (PX).', 'rankfortress' ); ?>
</p>

<?php
 }
 
 function rankfortress_paragraph_font_size_cb( $args ){
     // Get the value of the setting we've registered with register_setting()
     $options = get_option( 'rankfortress_options' );
      
     ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    data-custom="<?php echo esc_attr( $args['rankfortress_custom_data'] ); ?>"
    value="<?php echo $options[$args['label_for']]; ?>" />

<p class="description">
    <?php esc_html_e( 'Define the font size value in Pixel (PX).', 'rankfortress' ); ?>
</p>
<?php
  }
 
 
 function rankfortress_paragraph_font_color_cb( $args ){
     // Get the value of the setting we've registered with register_setting()
     $options = get_option( 'rankfortress_options' );
      
     ?>

<input type="text" class="color-picker" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    data-custom="<?php echo esc_attr( $args['rankfortress_custom_data'] ); ?>"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php
  }

function rankfortress_margin_bottom_cb($args){
    $options = get_option( 'rankfortress_options' );
?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    data-custom="<?php echo esc_attr( $args['rankfortress_custom_data'] ); ?>"
    value="<?php echo $options[$args['label_for']]; ?>" />

<p class="description">
    <?php esc_html_e( 'Define the spacing between components. The values define will be in pixels.', 'rankfortress' ); ?>
</p>

<?php
}

function rankfortress_heading_alignment_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_options' );
     
    ?>

<select id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_options[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>">
    <option value="left" <?php selected( $options['rankfortress_heading_alignment'], 'left' ); ?>>Left</option>
    <option value="center" <?php selected( $options['rankfortress_heading_alignment'], 'center' ); ?>>Center</option>
    <option value="right" <?php selected( $options['rankfortress_heading_alignment'], 'right' ); ?>>Right</option>
</select>

<?php

}