<?php

function fields_settings(){

    add_settings_field(
        'rankfortress_neighborhood_location',
        __( 'Location (City)', 'rankfortress' ),
        'rankfortress_neighborhood_location_cb',
        'rankfortress_settings',
        'rankfortress_settings_neighborhood',
        array(
            'label_for'         => 'rankfortress_neighborhood_location',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_neighborhood_limit',
        __( 'Limit', 'rankfortress' ),
        'rankfortress_neighborhood_limit_cb',
        'rankfortress_settings',
        'rankfortress_settings_neighborhood',
        array(
            'label_for'         => 'rankfortress_neighborhood_limit',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_neighborhood_sort',
        __( 'Sort By', 'rankfortress' ),
        'rankfortress_neighborhood_sort_cb',
        'rankfortress_settings',
        'rankfortress_settings_neighborhood',
        array(
            'label_for'         => 'rankfortress_neighborhood_sort',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    

    add_settings_field(
        'rankfortress_activities_location',
        __( 'Location (City)', 'rankfortress' ),
        'rankfortress_activities_location_cb',
        'rankfortress_settings',
        'rankfortress_settings_activities',
        array(
            'label_for'         => 'rankfortress_activities_location',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_activities_limit',
        __( 'Limit', 'rankfortress' ),
        'rankfortress_activities_limit_cb',
        'rankfortress_settings',
        'rankfortress_settings_activities',
        array(
            'label_for'         => 'rankfortress_activities_limit',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_activities_sort',
        __( 'Sort By', 'rankfortress' ),
        'rankfortress_activities_sort_cb',
        'rankfortress_settings',
        'rankfortress_settings_activities',
        array(
            'label_for'         => 'rankfortress_activities_sort',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_activities_types',
        __( 'Places Types', 'rankfortress' ),
        'rankfortress_activities_types_cb',
        'rankfortress_settings',
        'rankfortress_settings_activities',
        array(
            'label_for'         => 'rankfortress_activities_types',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_activities_radius',
        __( 'Radius', 'rankfortress' ),
        'rankfortress_activities_radius_cb',
        'rankfortress_settings',
        'rankfortress_settings_activities',
        array(
            'label_for'         => 'rankfortress_activities_radius',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_locations_sentence',
        __( 'Sentence Limit', 'rankfortress' ),
        'rankfortress_locations_sentence_cb',
        'rankfortress_settings',
        'rankfortress_settings_location',
        array(
            'label_for'         => 'rankfortress_locations_sentence',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );


    add_settings_field(
        'rankfortress_gmap_location',
        __( 'Location (City)', 'rankfortress' ),
        'rankfortress_gmap_location_cb',
        'rankfortress_settings',
        'rankfortress_settings_map',
        array(
            'label_for'         => 'rankfortress_gmap_location',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );


    add_settings_field(
        'rankfortress_gmap_radius',
        __( 'Zoom Level', 'rankfortress' ),
        'rankfortress_gmap_radius_cb',
        'rankfortress_settings',
        'rankfortress_settings_map',
        array(
            'label_for'         => 'rankfortress_gmap_radius',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_gmap_height',
        __( 'Map Height', 'rankfortress' ),
        'rankfortress_gmap_height_cb',
        'rankfortress_settings',
        'rankfortress_settings_map',
        array(
            'label_for'         => 'rankfortress_gmap_height',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );


    add_settings_field(
        'rankfortress_gmap_api',
        __( 'API Key', 'rankfortress' ),
        'rankfortress_gmap_api_cb',
        'rankfortress_settings',
        'rankfortress_settings_api',
        array(
            'label_for'         => 'rankfortress_gmap_api',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );

    add_settings_field(
        'rankfortress_ow_api',
        __( 'API Key', 'rankfortress' ),
        'rankfortress_ow_api_cb',
        'rankfortress_settings',
        'rankfortress_settings_ow_api',
        array(
            'label_for'         => 'rankfortress_ow_api',
            'class'             => 'rankfortress_row',
            'rankfortress_custom_data' => 'custom',
        )
    );
    
}


function rankfortress_neighborhood_location_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}


function rankfortress_neighborhood_limit_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}

function rankfortress_activities_radius_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p>Set the radius of area to cover. Max is 50000.</p>
<?php

}

function rankfortress_neighborhood_sort_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<select id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>">
    <option value="asc" <?php selected( $options['rankfortress_neighborhood_sort'], 'asc' ); ?>>Ascending</option>
    <option value="desc" <?php selected( $options['rankfortress_neighborhood_sort'], 'desc' ); ?>>Descending</option>
    <option value="rand" <?php selected( $options['rankfortress_neighborhood_sort'], 'rand' ); ?>>Randomize</option>
</select>

<?php

}


function rankfortress_activities_location_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}


function rankfortress_activities_limit_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}

function rankfortress_activities_sort_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<select id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>">
    <option value="asc" <?php selected( $options['rankfortress_activities_sort'], 'asc' ); ?>>Ascending</option>
    <option value="desc" <?php selected( $options['rankfortress_activities_sort'], 'desc' ); ?>>Descending</option>
    <option value="rand" <?php selected( $options['rankfortress_activities_sort'], 'rand' ); ?>>Randomize</option>
</select>

<?php

}

function rankfortress_activities_types_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p>Separate types with commas without spaces. For more available places types, you can refer to this <a
        href="https://developers.google.com/maps/documentation/javascript/local-context/supported-types"
        target="_blank">link</a>. </p>
<?php

}


function rankfortress_locations_sentence_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}


function rankfortress_gmap_radius_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p>Zoom Level Options: 1 - 19.</p>
<?php

}

function rankfortress_gmap_height_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="number" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p>Define the height of google map on desktop.</p>
<?php

}

function rankfortress_gmap_location_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />

<?php

}

function rankfortress_gmap_api_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p><small>
        This API key can be obtained from
        the <a href="https://console.developers.google.com" target="_BLANK">Google Developers Console</a>. Our <a
            href="http://www.wpgmaps.com/documentation/creating-a-google-maps-api-key/"
            target="_BLANK">documentation</a> provides a full guide on how to obtain this. </small></p>
<?php

}

function rankfortress_ow_api_cb( $args ){
    // Get the value of the setting we've registered with register_setting()
    $options = get_option( 'rankfortress_settings' );
     
    ?>

<input type="text" id="<?php echo esc_attr( $args['label_for'] ); ?>"
    name="rankfortress_settings[<?php echo esc_attr( $args['label_for'] ); ?>]"
    value="<?php echo $options[$args['label_for']]; ?>" />
<p><small>
        This API key can be obtained from
        the <a href="https://openweathermap.org/" target="_BLANK">OpenWeather</a> website. Our <a
            href="https://rankfortresstools.com/support/article/6-Create-OpenWeather-API-Key"
            target="_blank">documentation</a> provides a guode on how to obtain it.</p>
<?php

}