<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://rankfortress.com/
 * @since             1.0.0
 * @package           Location_Geocentric
 *
 * @wordpress-plugin
 * Plugin Name:       Location Geocentric
 * Plugin URI:        https://rankfortress.com/
 * Description:       This is a premium plugin built by Rank Fortress.
 * Version:           1.0.21
 * Author:            RankFortress
 * Author URI:        https://rankfortress.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       location-geocentric
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}


global $site_search_license;

require __DIR__ . '/vendor/autoload.php';


/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */
define( 'LOCATION_GEOCENTRIC_VERSION', '1.0.0' );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-location-geocentric-activator.php
 */
function activate_location_geocentric() {
    
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-location-geocentric-activator.php';
	Location_Geocentric_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-location-geocentric-deactivator.php
 */
function deactivate_location_geocentric() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-location-geocentric-deactivator.php';
	Location_Geocentric_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_location_geocentric' );
register_deactivation_hook( __FILE__, 'deactivate_location_geocentric' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-location-geocentric.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_location_geocentric() {

	$plugin = new Location_Geocentric();
	$plugin->run();

}
run_location_geocentric();

function getLicense(){
    return '32fbd9f1-316d-45b8-b7f5-f40cbaf67fd7';
}

function appsero_init_tracker_location_geocentric() {
    
    $appsero = new Appsero;

    $client = new Appsero\Client( '32fbd9f1-316d-45b8-b7f5-f40cbaf67fd7', 'Location Geocentric', __FILE__ );

    // Active insights
    $client->insights()->init();

    // Active automatic updater
    $client->updater();

    // Active license page and checker
    $appsero->appsero_page_checker($client);

}

appsero_init_tracker_location_geocentric();